package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConfRestricaoOrgaoConcedenteDAO;
import com.rjconsultores.ventaboletos.entidad.ConfRestricaoOrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.service.ConfRestricaoOrgaoConcedenteService;
import com.rjconsultores.ventaboletos.service.OrgaoConcedenteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("confRestricaoOrgaoConcedenteService")
public class ConfRestricaoOrgaoConcedenteServiceImpl implements ConfRestricaoOrgaoConcedenteService {

	@Autowired
	ConfRestricaoOrgaoConcedenteDAO confRestricaoOrgaoConcedenteDAO;
	@Autowired
	private OrgaoConcedenteService orgaoConcedenteService;

	@Override
	public List<ConfRestricaoOrgaoConcedente> obtenerTodos() {
		return confRestricaoOrgaoConcedenteDAO.obtenerTodos();
	}

	@Override
	public ConfRestricaoOrgaoConcedente obtenerID(Integer id) {
		return confRestricaoOrgaoConcedenteDAO.obtenerID(id);
	}

	@Override
	public ConfRestricaoOrgaoConcedente obtenerOrgaoCOncedenteTodos() {

		ConfRestricaoOrgaoConcedente entidad = new ConfRestricaoOrgaoConcedente();

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		OrgaoConcedente orgaoConcedente = orgaoConcedenteService.obtenerID(-1);
		entidad.setOrgaoConcedente(orgaoConcedente);

		return entidad;
	}

	@Override
	@Transactional
	public ConfRestricaoOrgaoConcedente suscribir(ConfRestricaoOrgaoConcedente entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoOrgaoConcedenteDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public ConfRestricaoOrgaoConcedente actualizacion(ConfRestricaoOrgaoConcedente entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoOrgaoConcedenteDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(ConfRestricaoOrgaoConcedente entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		confRestricaoOrgaoConcedenteDAO.actualizacion(entidad);
	}

}
